#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "vesa.h"
#include "bitmap.h"

#define  RES_X 320
#define  RES_Y 200
#define  MID_X 160
#define  MID_Y 100

void Set_Mode (short modo);
#pragma aux Set_Mode=\
"int    10h"\
modify  [ax]\
parm    [ax]

void move32 (unsigned char *ori, unsigned char *dst, int size);
#pragma aux move32 = \
 "   shr    ecx,2                   ",\
 "   rep    movsd                   ",\
   parm [esi] [edi] [ecx] modify [eax];

//Rutina de lectura de ficheros TGA (sin comprimir). Utiliza la estructura BITMAP
//definida en el fichero 'bitmap.h'

BITMAP  ReadTGA(char *Src)
{
        BITMAP  ret;
        uword   *SrcW;
        char    *src;
        char    *dst;
        int     x,y;
        int     mx;
        
        SrcW=(uword *) Src;

        ret.Width=*(SrcW+6);
        ret.Height=*(SrcW+7);
        ret.Size=ret.Width*ret.Height*3;
        ret.Src=(char *) malloc(ret.Size);
        mx=ret.Width*3;
        dst=(char *) (ret.Src+ret.Height*mx-mx);
        src=Src;
        src+=18;

        for(y=0;y<ret.Height;y++){
                for(x=0;x<mx;x++){
                        (*dst)=(*src);
                        src++;
                        dst++;
                }
                dst-=mx*2;
        }
        return(ret);
}

//  Rutinas para leer ficheros del disco duro

long filesize(FILE *stream)
{
   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);
   return length;
}

void GetHDData(char *src, unsigned char **dst)
{
 FILE *ftemp;
 ftemp = fopen(src,"rb");
 if (ftemp==NULL)
 {
     Set_Mode(0x3);
     printf ("File %s not found!\n",src);
     exit(1);
 }
 *dst = (unsigned char *)malloc(filesize(ftemp));
 fread(*dst,filesize(ftemp),1,ftemp);
 fclose(ftemp);
}

//   Esta es la rutina de dibujar lineas, basada en el algoritmo de Bresenham

void Line_luz (unsigned char *ori, unsigned char *dst,int x1,int y1,int x2,int y2)
{
    int i,deltax,deltay,numpix,
        d,dinc1,dinc2,
        xinc1,xinc2,
        yinc1,yinc2,
        offs,oinc1,oinc2,
        Rsum,Gsum,Bsum;

    // Inciciacion de variables y semejantes
    
    Rsum=0; Gsum=0;  Bsum=0;
    deltax= abs(x2-x1); deltay= abs(y2-y1);
    if (deltax>=deltay){numpix=deltax+1; d=((deltay<<1)-deltax);
                        dinc1=deltay<<1; dinc2=(deltay-deltax)<<1;
                        xinc1=3;  xinc2=3;  yinc1=0;  yinc2=320*3;}
    else               {numpix=deltay+1; d=((deltax<<1)-deltay);
                        dinc1=deltax<<1; dinc2=(deltax-deltay)<<1;
                        xinc1=0;  xinc2=3;  yinc1=320*3; yinc2=320*3;}
    if (x1>x2){ xinc1=-xinc1; xinc2=-xinc2;}
    if (y1>y2){ yinc1=-yinc1; yinc2=-yinc2;}
    offs=(320*y1+x1)*3; oinc1=xinc1+yinc1;  oinc2=xinc2+yinc2;

    //  Empieza a dibujar la linea

    for (i=0;i<numpix;i++)
    {
        // Esta parte es la que realiza el efecto en si, en vez de poner un color fijo en cada
        // punto.
    
        if (Rsum<(1<<14))
        {
            Rsum+=ori[offs];
            dst[offs]=min((Rsum>>6)+ori[offs],254);
        }else dst[offs]=255;
        if (Gsum<(1<<14))
        {
            Gsum+=ori[offs+1];
            dst[offs+1]=min((Gsum>>6)+ori[offs+1],254);
        }else dst[offs+1]=255;
        if (Bsum<(1<<14))
        {
            Bsum+=ori[offs+2];
            dst[offs+2]=min((Bsum>>6)+ori[offs+2],254);
        }else dst[offs+2]=255;

        //  Aqui ya vuelve a ser el tipico algoritmo de la recta

        if (d<0)
        {   d+=dinc1; offs+=oinc1;}
        else
        {   d+=dinc2; offs+=oinc2;}
    }
};

// La rutina principial (no la mas compleja) del efecto

efecto (unsigned char *ori,unsigned char *dest, int xl, int yl)
{
    int xc;
    for (xc=0;xc<320;xc++)
    {
        Line_luz (ori,dest,xl,yl,xc,0);
        Line_luz (ori,dest,xl,yl,xc,199);
    }
    for (xc=1;xc<199;xc++)
    {
        Line_luz (ori,dest,xl,yl,0,xc);
        Line_luz (ori,dest,xl,yl,319,xc);
    }
}

int clear;

void main(int argc, char *argv[])
{
    int c;
    float cp;
    unsigned char *Virtpant1;
    unsigned char *Virtpant2;
    unsigned char *texture;

    BITMAP imagen;

    if (argc<2) exit(1);

    Active.Screen.Width=320;
    Active.Screen.Height=200;
    Active.Screen.bpp=32;

    Active.Work.Width=RES_X;
    Active.Work.Height=RES_Y;
    Active.Work.bpp=24;

    //if EnableLFB is TRUE, LFB is activated if available
    Active.EnableLFB=1;

    if (!InitSetMode())
    {
        Active.Screen.bpp=24;
        if (!InitSetMode())
        {
            Active.Screen.bpp=16;
            if (!InitSetMode())
            {
                Active.Screen.bpp=15;
                if (!InitSetMode())
                {
                    Active.Screen.bpp=-1;
                    Active.Screen.Height*=2;
                    InitSetMode();
                }
            }
        }
    }
    Virtpant1=malloc(RES_X*RES_Y*3);
    Virtpant2=malloc(RES_X*RES_Y*3);
    for (c=0;c<RES_X*RES_Y*3;c++)
    {
        Virtpant1[c]=0;
        Virtpant2[c]=0;
    }
    GetHDData(argv[1],&texture);
    imagen=ReadTGA(texture);
    move32(imagen.Src,Virtpant1,320*200*3);
    free (texture);
    cp=0;
    while(!kbhit())
    {
         efecto(Virtpant1,Virtpant2,160+120*sin(cp/20),100+80*cos(cp/23));
         Flip(Virtpant2);
         cp++;
    }    getch();
    free(imagen.Src);

    Set_Mode(0x3);
    Free_Memory();
    printf("[#] Salio\n");
}


